/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: kernel_impl.h 345 2014-09-16 23:55:32Z fsi-dankei $
 */

/*
 *		ATK2ɸإåե
 *
 *  ΥإåեϡͥץΥե
 *  ɬ󥯥롼ɤ٤ɸإåեǤ
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤ
 *  ˤꡤޥʳ褦ˤʤäƤ
 */

#ifndef TOPPERS_KERNEL_IMPL_H
#define TOPPERS_KERNEL_IMPL_H

/*
 *  ͥѥ͡Ѥ뤿
 */
#ifndef TOPPERS_SVC_FUNCCALL
#define TOPPERS_SVC_FUNCCALL
#endif

/*
 *  ץꥱȶ̤Υإåե
 */
#define OMIT_INCLUDE_OS_LCFG
#include "Os.h"

/* ̵ݥ */
#ifndef NULL
#define NULL		NULL_PTR
#endif /* NULL */

/*
 *  㥹ȤԤޥ
 */
#ifndef CAST
#define CAST(type, val)		((type) (val))
#endif /* CAST */

#ifndef TOPPERS_MACRO_ONLY

/* Ŭ뤿ᡤ¸Ǥ뷿 */
#ifndef OMIT_DATA_TYPE
/*
 *  ͥΥǡ
 */
typedef uint32	InterruptNumberType;            /* ֹ */
typedef uint32	AttributeType;                  /* ֥Ȥ° */
typedef sint32	PriorityType;                   /* ͥ */
#endif /* OMIT_DATA_TYPE */

typedef void (*FunctionRefType)(void);          /* ץεư */

/*
 *  顼եåOFFӥIDȥѥ᡼OFFˤʤ
 */
#ifdef CFG_USE_ERRORHOOK

#ifdef CFG_USE_PARAMETERACCESS
extern _ErrorHook_Par	_errorhook_par1;
extern _ErrorHook_Par	_errorhook_par2;
extern _ErrorHook_Par	_errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

#endif /* CFG_USE_ERRORHOOK */

/*
 *  OSShutdownOSθƤӽФ
 */
extern void internal_shutdownos(StatusType ercd);

#ifdef CFG_USE_SHUTDOWNHOOK
extern void internal_call_shtdwnhk(StatusType ercd);
#endif /* CFG_USE_SHUTDOWNHOOK */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ASSERTޥ
 */
#ifndef NDEBUG
#define ASSERT(exp) do {								\
		if (!(exp)) {									\
			fatal_file_name = __FILE__;					\
			fatal_line_num = __LINE__;					\
			internal_shutdownos(E_OS_SYS_ASSERT_FATAL);	\
		}												\
} while (0)

#else /* NDEBUG */
#define ASSERT(exp)
#endif /* NDEBUG */

/*
 *  åȰ¸
 */
#include "target_config.h"

/*
 *  ٤Ƥδؿ򥳥ѥ뤹뤿
 */
#ifdef ALLFUNC
#include "allfunc.h"
#endif /* ALLFUNC */

/*
 *  ץꥱ⡼ͤ
 */
#define APPMODE_NONE	((AppModeType) 0)   /* ⡼ɤʤ */

/*
 *  ¹Υƥȡcallevel_statβ12ӥåȡˤͤ
 *  TCL_NULLλˡθƽвƥȤȽ̤Ǥʤʤ뤳Ȥ
 */
#define TCL_NULL			UINT_C(0x0000)                          /* ƥॵӥƤӽФʤ */
#define TCL_TASK			UINT_C(0x0001)                          /*  */
#define TCL_ISR2			UINT_C(0x0002)                          /* C2ISR */
#define TCL_PROTECT			UINT_C(0x0004)                          /* ProtectionHook */
#define TCL_PREPOST			UINT_C(0x0008)                          /* PreTaskHookPostTaskHook */
#define TCL_SYS_STARTUP		UINT_C(0x0010)                          /* ƥStartupHook */
#define TCL_SYS_SHUTDOWN	UINT_C(0x0020)                          /* ƥShutdownHook */
#define TCL_SYS_ERROR		UINT_C(0x0040)                          /* ƥErrorHook */
#define TCL_OSAP_STARTUP	UINT_C(0x0100)                          /* OSץꥱ˽°StartupHook */
#define TCL_OSAP_SHUTDOWN	UINT_C(0x0200)                          /* OSץꥱ˽°ShutdownHook */
#define TCL_OSAP_ERROR		UINT_C(0x0400)                          /* OSץꥱ˽°ErrorHook */
#define TCL_STARTUP			(TCL_SYS_STARTUP | TCL_OSAP_STARTUP)    /* StartupHook */
#define TCL_SHUTDOWN		(TCL_SYS_SHUTDOWN | TCL_OSAP_SHUTDOWN)  /* ShutdownHook */
#define TCL_ERROR			(TCL_SYS_ERROR | TCL_OSAP_ERROR)        /* ErrorHook */
#define TCL_OSAP_MASK		(TCL_OSAP_STARTUP | TCL_OSAP_SHUTDOWN | TCL_OSAP_ERROR)
/* OSץꥱ˽°Υեåޥ */
#define TCLMASK				UINT_C(0x0fff)                          /* ٥򼨤ӥåȤΥޥ */

/*
 *  ƥ (callevel_statξ4ӥå)ͤ
 */
#define TSYS_NULL			UINT_C(0x0000)      /* ƥ֥ꥢ */
#define TSYS_DISALLINT		UINT_C(0x1000)      /* DisableAllInterruptsȯ */
#define TSYS_SUSALLINT		UINT_C(0x2000)      /* SuspendAllInterruptsȯ */
#define TSYS_SUSOSINT		UINT_C(0x4000)      /* SuspendOSInterruptsȯ */
#define TSYS_ISR1			UINT_C(0x8000)      /* C1ISRưѤ */
#define TSYSMASK			UINT_C(0xf000)      /* ƥ֤򼨤ӥåȤΥޥ */


#ifdef CFG_USE_STACKMONITORING
#ifndef STACK_MAGIC_NUMBER
/*
 *  å˥ѥޥåʥС
 *  åȰ¸ͥ褵
 */
#define STACK_MAGIC_NUMBER	0x4E434553      /* NCESASCII(0x4E434553) */
#endif /* STACK_MAGIC_NUMBER */

#ifndef TOPPERS_ISTK_MAGIC_REGION
/* ߥåѥޥåʥСΰޥ */
#define TOPPERS_ISTK_MAGIC_REGION(stk, stksz)	(stk)
#endif /* TOPPERS_ISTK_MAGIC_REGION */

#ifndef TOPPERS_SSTK_MAGIC_REGION
/* ꥿åѥޥåʥСΰޥ */
#ifndef USE_TSKINICTXB
#define TOPPERS_SSTK_MAGIC_REGION(p_tinib)	((StackType *) ((p_tinib)->sstk))
#endif /* USE_TSKINICTXB */
#endif /* TOPPERS_SSTK_MAGIC_REGION */

#endif /* CFG_USE_STACKMONITORING */

#define TFN_EXIT_TASK	(TMAX_SVCID - TARGET_SVC_NUM)
#define exit_task		(_kernel_exit_task)

/*
 *  եå̤
 */
#define STARTUP_HOOK	UINT_C(0)
#define SHUTDOWN_HOOK	UINT_C(1)
#define ERROR_HOOK		UINT_C(2)

/*
 *  ץƥեå顼ץ
 */
#define PROTECTION_ERROR_OPTIONAL_BIT	(PEOB_STACKMONITORING_INTERRUPT | PEOB_STACKMONITORING_DISPATCH | PEOB_STACKMONITORING_TERMTASK)
#define PEOB_STACKMONITORING_INTERRUPT	UINT_C(0x80)
#define PEOB_STACKMONITORING_DISPATCH	UINT_C(0x40)
#define PEOB_STACKMONITORING_TERMTASK	UINT_C(0x20)
/*
 *  callevel_statΥӥå
 */
#define ENTER_CALLEVEL(bit)		(callevel_stat |= (bit))
#define LEAVE_CALLEVEL(bit)		(callevel_stat &= (uint16) ~(bit))


/*
 *  ƥƥॵӥƤӽФñ
 */
#define CALLEVEL_ACTIVATETASK				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_TERMINATETASK				(TCL_TASK)
#define CALLEVEL_CHAINTASK					(TCL_TASK)
#define CALLEVEL_SCHEDULE					(TCL_TASK)
#define CALLEVEL_GETTASKID					(TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT | TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST | TCL_PROTECT)
#define CALLEVEL_GETTASKSTATE				(TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT | TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST)
#define CALLEVEL_GETRESOURCE				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_RELEASERESOURCE			(TCL_TASK | TCL_ISR2)
#define CALLEVEL_SETEVENT					(TCL_TASK | TCL_ISR2)
#define CALLEVEL_CLEAREVENT					(TCL_TASK)
#define CALLEVEL_GETEVENT					(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST)
#define CALLEVEL_WAITEVENT					(TCL_TASK)
#define CALLEVEL_GETALARMBASE				(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST)
#define CALLEVEL_GETALARM					(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST)
#define CALLEVEL_SETRELALARM				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_SETABSALARM				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_CANCELALARM				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_GETACTIVEAPPMODE			(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN)
#define CALLEVEL_SHUTDOWNOS					(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_STARTUP)
#define CALLEVEL_GETISRID					(TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT | TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PROTECT)
#define CALLEVEL_INCREMENTCOUNTER			(TCL_TASK | TCL_ISR2)
#define CALLEVEL_GETCOUNTERVALUE			(TCL_TASK | TCL_ISR2)
#define CALLEVEL_GETELAPSEDVALUE			(TCL_TASK | TCL_ISR2)
#define CALLEVEL_STARTSCHEDULETABLEREL		(TCL_TASK | TCL_ISR2)
#define CALLEVEL_STARTSCHEDULETABLEABS		(TCL_TASK | TCL_ISR2)
#define CALLEVEL_STOPSCHEDULETABLE			(TCL_TASK | TCL_ISR2)
#define CALLEVEL_NEXTSCHEDULETABLE			(TCL_TASK | TCL_ISR2)
#define CALLEVEL_GETSCHEDULETABLESTATUS		(TCL_TASK | TCL_ISR2)
#define CALLEVEL_GETAPPLICATIONID			(TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT | TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN | TCL_PROTECT)
#define CALLEVEL_CALLTRUSTEDFUNCTION		(TCL_TASK | TCL_ISR2)
#define CALLEVEL_CHECKISRMEMORYACCESS		(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PROTECT)
#define CALLEVEL_CHECKTASKMEMORYACCESS		(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PROTECT)
#define CALLEVEL_CHECKOBJECTACCESS			(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PROTECT)
#define CALLEVEL_CHECKOBJECTOWNERSHIP		(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PROTECT)
#define CALLEVEL_GETAPPLICATIONSTATE		(TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT | TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN | TCL_PROTECT)
#define CALLEVEL_DISABLEINTERRUPTSOURCE		(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN | TCL_PROTECT | TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT)
#define CALLEVEL_ENABLEINTERRUPTSOURCE		(TCL_TASK | TCL_ISR2 | TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN | TCL_PROTECT | TSYS_DISALLINT | TSYS_SUSALLINT | TSYS_SUSOSINT)
#define CALLEVEL_GETFAULTYCONTEXT			(TCL_PROTECT)
#define CALLEVEL_IOCSEND					(TCL_TASK | TCL_ISR2)
#define CALLEVEL_IOCWRITE					(TCL_TASK | TCL_ISR2)
#define CALLEVEL_IOCRECEIVE					(TCL_TASK | TCL_ISR2)
#define CALLEVEL_IOCREAD					(TCL_TASK | TCL_ISR2)
#define CALLEVEL_IOCEMPTYQUEUE				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_ALLOWACCESS				(TCL_TASK | TCL_ISR2)
#define CALLEVEL_TERMINATEAPPLICATION		(TCL_TASK | TCL_ISR2 | TCL_OSAP_ERROR)

/*
 *  ¾͡ɸߥǥ
 */
#define TIPM_ENAALL		UINT_C(0)   /* ͥ٥ޥ */

/*
 *  ֥°ɸߥǥ
 */
#define ENABLE		UINT_C(0x01)
#define DISABLE		UINT_C(0x00)


/*
 *  OS̵ʥƥॵӥID
 */
#define OSServiceId_Invalid		((OSServiceIdType) 0xff)

/*
 *  إåեʤ⥸塼δؿѿ
 */
#ifndef TOPPERS_MACRO_ONLY

#ifdef TOPPERS_StartOS
/*
 *  ץꥱ⡼ɤο
 */
extern const AppModeType	tnum_appmode;

#endif /* TOPPERS_StartOS */

/*
 *  OS¹Τѿosctl_manage.c
 */
extern uint16				callevel_stat;  /* ¹Υƥ */
extern AppModeType			appmodeid;      /* ץꥱ⡼ID */

/*
 *  ͥư֥ե饰
 */
extern boolean				kerflg;

/*
 *  ø⡼ɤư椫򼨤ե饰
 */
extern boolean				run_trusted;

/*
 *  顼եåƤӽФΤosctl.c
 */
#ifdef CFG_USE_ERRORHOOK
extern void internal_call_errorhook(StatusType ercd, OSServiceIdType svcid);
#endif /* CFG_USE_ERRORHOOK */

/*
 *  ݥȥեå/ץ쥿եå
 *  å˥󥰵ǽν/ץƥեåƤӽФΤosctl.c
 */
#ifdef CFG_USE_POSTTASKHOOK
extern void call_posttaskhook(void);
#endif /* CFG_USE_POSTTASKHOOK */

#ifdef CFG_USE_PRETASKHOOK
extern void call_pretaskhook(void);
#endif /* CFG_USE_PRETASKHOOK */

#ifdef CFG_USE_STACKMONITORING
extern void init_stack_magic_region(void);
#endif /* CFG_USE_STACKMONITORING */

extern void cancel_shutdown_hook(void);
extern void callevel_chk_shutdown(StatusType ercd);

extern void call_protectionhk_main(StatusType peob_ercd);

/*
 *  ƥ⥸塼νOs_Lcfg.c
 */
extern void object_initialize(void);

/*
 *  ƥ⥸塼νλOs_Lcfg.c
 */
extern void object_terminate(void);

/*
 *  󥿥ƥѤΥåΰOs_Lcfg.c
 */
extern const MemorySizeType	_ostksz;        /* åΰΥʴݤ᤿͡ */
extern StackType * const	_ostk;          /* åΰƬ */
#ifdef TOPPERS_OSTKPT
extern StackType * const	_ostkpt;        /* åݥ󥿤ν */
#endif /* TOPPERS_OSTKPT */

extern const MemorySizeType	_nthkstksz;
extern StackType * const	_nthkstk;

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_KERNEL_IMPL_H */
