/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: sample1.c 492 2014-09-29 05:35:11Z t_ishikawa $
 */

/*
 *		OSץꥱ°ץץ
 *
 *  ATK2-SC3δŪưǧ뤿Υץץࡥ
 *
 *  ץγסPCȥܡɴ֤ǥꥢ̿Ԥ桼
 *  ޥɤ˱ưȥϤԤʤ
 *
 *  㥳ޥɰ
 *  
 *    '1' : ʹߤΥޥɤ Task1 ФƹԤ
 *    '2' : ʹߤΥޥɤ Task2 ФƹԤ
 *    '3' : ʹߤΥޥɤ Task3 ФƹԤ
 *    '4' : ʹߤΥޥɤ Task4 ФƹԤ
 *    '5' : ʹߤΥޥɤ Task5 ФƹԤ
 *    '6' : ʹߤΥޥɤ Task6 ФƹԤ
 *    '7' : ʹߤΥޥɤ Task7 ФƹԤ
 *    '8' : ʹߤΥޥɤ Task8 ФƹԤ(ޥɻѤǤʤ)
 *    '9' : ʹߤΥޥɤ Task9 ФƹԤ(ޥɻѤǤʤ)
 *  ǽ
 *    'a' : ActivateTask ˤƥư롥
 *    'A' : TerminateTask ˤƥλ롥
 *    '!'(Shift+1) : ChainTask ˤƥλTask1 ư
 *    '"'(Shift+2) : ChainTask ˤƥλTask2 ư
 *    '#'(Shift+3) : ChainTask ˤƥλTask3 ư
 *    '$'(Shift+4) : ChainTask ˤƥλTask4 ư
 *    '%'(Shift+5) : ChainTask ˤƥλTask5 ư
 *    's' : Υץꥨץƥ°Ǥ륿 MainTask ˤƺǹ
 *          ͥ٥ HighPriorityTask ưSchedule ˤ
 *          ƥ塼󥰤Ԥ
 *    'S' : Υץꥨץƥ֥ NonPriTask ư
 *          Υץꥨץƥ֥ NonPriTask ˤƺǹͥ
 *           HighPriorityTask ưλ
 *    'y' : 11(åͭ)ƤӽФؿǽԤ
 *    'Y' : 12(åͭ)ƤӽФؿǽԤ
 *          λˤꡤ顼ɤE_OS_MISSINGEND
 *          顼եåƤФ
 *    'z' : ¹Υ GetTaskID ¹Ԥơ¹Ծ֤ TaskID 
 *    'Z' : ᥤ󥿥 GetTaskState ¹Ԥơоݥξ֤
 *    'x' : div̿¹Ԥơ̤̿㳰ȯ
 *  ߴǽ
 *    'd' : DisableAllInterrupts ¹Ը塤ߥޡͤ3ɽ
 *           EnableAllInterrupts ¹Ԥ
 *    'D' : SuspendAllInterrupts ¹Ը塤ߥޡͤ3ɽ
 *           SuspendAllInterrupts ¹Ը塤ߥ
 *          ޡͤ3ɽResumeAllInterrupts ¹Ը塤
 *          ޡͤ3ɽResumeAllInterrupts ¹Ԥ
 *    'f' : SuspendOSInterrupts ¹Ը塤ߥޡͤ3ɽ
 *           SuspendOSInterrupts ¹Ը塤ߥ
 *          ޡͤ3ɽ SuspendAllInterrupts¹
 *          塤ߥޡͤ3ɽ ResumeAllInterrupts
 *          ¹Ը塤ߥޡͤ3ɽ
 *          ResumeOSInterrupts ¹Ըߥޡͤ3ɽ
 *          ResumeOSInterrupts ¹Ԥ
 *    'T' : ߥޡͤ3ɽ
 *  ꥽ǽ
 *    'k' : GetResource ˤƥ꥽ TskLevelRes 롥ʤ
 *          Task3 ϡΥ꥽ͥ٤⤤ᥨ顼Ȥʤ
 *    'K' : ReleaseResource ˤƥ꥽ TskLevelRes 
 *    'i' : GetResource ˤƥ꥽ CntRes 塤
 *          ޡͤ3ɽReleaseResource ˤƥ꥽
 *          CntRes 
 *  ٥浡ǽ
 *    'e' : SetEvent ˤƥ٥Ȥꤹ롥Task2  Task3 ʳ
 *          Ƥʤᥨ顼Ȥʤ
 *    'w' : ClearEvent ˤƼΥ٥Ȥ򥯥ꥢ롥Task2 
 *          Task3 ʳϳƤʤᥨ顼Ȥʤ
 *    'E' : GetEvent ˤƥ٥Ⱦ֤롥Task2  Task3
 *          ʳϳƤʤᥨ顼Ȥʤ
 *    'W' : WaitEvent ˤƼΥ٥ȤԤġTask3  Task4
 *          ʳϥ顼Ȥʤ
 *  顼ൡǽ
 *    'b' : GetAlarmBase ˤƥ顼 MainCycArm Υ顼١
 *          
 *    'B' : GetAlarm ˤƥ顼 MainCycArm λĤꥫͤ2
 *          Ϣ³Ǽ
 *    'v' : SetRelAlarm ˤƥ顼 ActTskArm ư500ms 
 *           Task1 ư
 *    'V' : SetRelAlarm ˤƥ顼 SetEvtArm ư500ms 
 *          ٥ T3Evt ꤹ
 *    'h' : CancelAlarm ˤƥ顼 ActTskArm 򥭥󥻥뤹
 *  ǽ
 *    'c' : ˤ IncrementCounter ¹Ԥ SampleCnt
 *          ˥ʥΤ
 *          1 ʥǥ顼 SampleArm λХå
 *          ¹Ԥ
 *    'C' : ˤ IncrementCounter ¹Ԥ SampleCnt2
 *          ˥ʥΤ
 *          1 ʥǥ顼 SampleArm1 λSampleCnt3 
 *          󥯥Ȥ롥 SampleCnt3  1 ʥ SampleAlm2
 *          λХå¹Ԥ
 *    'j' : ˤ GetCounterValue ¹Ԥ
 *          ͤ¸
 *    'J' : ˤ GetEalsedCounterValue ¹Ԥ
 *          ͤGetCounterValue ޤ GetEalsedCounterValue ˤƼ
 *          ͤȤ롥󡤤ޤϡGetCounterValue¹ԤƤʤ0
 *          Ȥ
 *
 *    'r' : ˤ GetISRID¹Ԥ
 *          ƥȤGetISRIDƽФϥ顼Ȥ
 *          INVALID_ISRֵѤ
 *
 *          ߥƥȤGetISRIDȯԤϡSystemTimerCntΥХå
 *          롼'n' ޥɤǼ¹ԡˤˤƹԤ
 *
 *          ƥȤGetISRIDȯԤϡSampleCnt2ΥХå
 *          롼'C' ޤ 'c' ޥɤǼ¹ԡˤˤƹԤ
 *
 *  塼ơ֥浡ǽ
 *    't' : 塼ơ֥ưON/OFF
 *
 *        'i' : SchtblSampleCnt󥿤򥤥󥯥Ȥ
 *              SchtblSampleCnt󥿤ϥ塼ơ֥ζư
 *        '1' : ʹߤΥޥɤ scheduletable1 ФƹԤ(ǥե)
 *        '2' : ʹߤΥޥɤ scheduletable2 ФƹԤ
 *        '3' : ʹߤΥޥɤ scheduletable3(¸ߤʤID) ФƹԤ
 *              ޥɤΥ顼ǧˤѤ
 *        's' : StartScheduleTableRel¹Ԥ(5)ǥ塼ơ֥򳫻Ϥ
 *        'S' : StartScheduleTableAbs¹Ԥ(5)ǥ塼ơ֥򳫻Ϥ
 *        'f' : StopScheduleTable¹Ԥ塼ơ֥ߤ
 *        'n' : NextScheduleTable¹Ԥscheduletable2ؤ
 *        'N' : NextScheduleTable¹Ԥscheduletable1ؤ
 *        'g' : GetScheduleTableStatus¹Ԥ塼ơ֥֤
 *        'q' : ShutdownOS( E_OK ) OS¹浡ǽ'q'Ʊǽ
 *        'Q' : ShutdownOS( E_OS_STATE ) OS¹浡ǽ'Q'Ʊǽ
 *
 *  OS¹浡ǽ
 *    'p' : GetActiveApplicationMode ˤƥץꥱ⡼ɤ
 *          
 *    'q' : ShutdownOS 򥳡 E_OK Ǽ¹Ԥץץ
 *          λ
 *    'Q' : ShutdownOS 򥳡 E_OS_STATE Ǽ¹Ԥץץ
 *          λ
 *
 *  IOCǽ
 *    'I' : IOC⡼
 *
 *        IOC APIѤ륿(IocTaskX)
 *        '1' : IocTask1(NT_osap1˽°)
 *        '2' : IocTask2(NT_osap2˽°)
 *        '3' : IocTask3(KT_osap1˽°)
 *        '4' : IocTask4(KT_osap2˽°)
 *
 *        IOC API
 *        '1' : IocSend_IOC_QUE_0(uint8 in1)
 *        '2' : IocSend_IOC_QUE_1(uint8 in1)
 *        '3' : IocWriteGroup_IOC_DEQUE(uint8 in1, uint8 in2, uint8 in3)
 *        '4' : IocReceive_IOC_QUE(uint8 *out1)
 *        '5' : IocReadGroup_IOC_DEQUE(uint8 *out1, uint8 *out2, uint8 *out3)
 *        '6' : IocEmptyQueue_IOC_QUE(void)
 *
 *        APIǡϤ
 *
 *  㥪֥Ȱ
 *  OS
 *    ȥåץեå
 *    åȥեå
 *    顼եå
 *    ץ쥿եå̤
 *    ݥȥեå̤
 *  
 *    ᥤ󥿥
 *      IDMainTask
 *      ͥ١14
 *      ¿ŵư1
 *      塼롧Υץꥨץƥ
 *      ưưAppMode1, AppMode2, AppMode3
 *      ס桼󥿥եʥꥢIOꥳޥɤ
 *            бưԤʤ
 *            顼 MainCycArm ˤꡤ10msȤԤ
 *            ޥɤμ̵ͭݡ󥰤
 *            ٥ȡIDMainEvtˤϢդƤ
 *    ǹͥ٥
 *      IDHighPriorityTask
 *      ͥ١15
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סưϤƽλ롥Υץꥨץƥ֥
 *            鵯ư졤ץꥨץȤƤ뤫ɤγǧ
 *    Υץꥨץƥ֥
 *      IDNonPriTask
 *      ͥ١1
 *      ¿ŵư8
 *      塼롧Υץꥨץƥ
 *      ưưʤ
 *      OSץꥱ˽°
 *      סưϤǹͥ٥ HighPriorityTask 
 *            ư塤λϤƥλ
 *    1
 *      IDTask1
 *      ͥ١4
 *      塼롧եץꥨץƥ
 *      ưưAppMode2
 *      ¿ŵư8
 *      סʥᥤ󥿥λˤư
 *            ư줹̵¥롼פꡤޥɽ¹Ԥ
 *            ꥽ TskLevelRes ϢդƤ
 *            ꥽ CntRes ϢդƤ
 *    2
 *      IDTask2
 *      ͥ١7
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סʥᥤ󥿥λˤư
 *            ư줹̵¥롼פꡤޥɽ¹Ԥ
 *            ꥽ TskLevelRes ϢդƤ
 *            ꥽ CntRes ϢդƤ
 *            ٥ T2Evt ϢդƤ
 *    3
 *      IDTask3
 *      ͥ١12
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưAppMode3
 *      סʥᥤ󥿥λˤư
 *            ư줹̵¥롼פꡤޥɽ¹Ԥ
 *            ٥Ԥ뤳ȤǽǤ
 *            ꥽ CntRes ϢդƤ
 *            ٥ T3Evt ϢդƤ
 *    4
 *      IDTask4
 *      ͥ١6
 *      ¿ŵư5
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סʥᥤ󥿥λˤư
 *            ư줹̵¥롼פꡤޥɽ¹Ԥ
 *            ꥽ TskLevelRes ϢդƤ
 *            ꥽ CntRes ϢդƤ
 *            ꥽ GroupRes ϢդƤ
 *    5
 *      IDTask5
 *      ͥ١9
 *      ¿ŵư5
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סʥᥤ󥿥λˤư
 *            ư줹̵¥롼פꡤޥɽ¹Ԥ
 *            ꥽ TskLevelRes ϢդƤ
 *            ꥽ CntRes ϢդƤ
 *            ꥽ GroupRes ϢդƤ
 *    6
 *      IDTask6
 *      ͥ١9
 *      ¿ŵư-
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      OSץꥱ˽°
 *      סʥᥤ󥿥λˤư
 *            SC3ǤϥƥॿȤƵư
 *            ư줹¨ؿλ
 *            ξǤTerminateTask¹Ԥ뤫ǧ
 *            ٵưƤOKȤʤ
 *            Task7ȥåͭ
 *    7
 *      IDTask7
 *      ͥ١8
 *      ¿ŵư-
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      OSץꥱ˽°
 *      סʥᥤ󥿥λˤư
 *            SC3Ǥϥ桼ȤƵư
 *            ư줹¨ؿλ
 *            ξǤTerminateTask¹Ԥ뤫ǧ
 *            ٵưƤOKȤʤ
 *            Task6ȥåͭ
 *    8
 *      IDTask8
 *      ͥ١8
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סưåϤ¤ΤʤTask1Ф
 *            GetTaskState()ȯԤơ顼եå夬
 *    9
 *      IDTask9
 *      ͥ١8
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סưåϤ¤ΤTask2Ф
 *            GetTaskState()ȯԤơTask2ΥơϤ
 *    10
 *      IDTask10
 *      ͥ١14
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סưåϤ٥(T10Evt)Ԥ
 *    11
 *      IDTask11
 *      ͥ١14
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סưåϤ٥(T11Evt)Ԥ
 *    12
 *      IDTask12
 *      ͥ١14
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סưåϤ٥(T12Evt)Ԥ
 *    13
 *      IDTask13
 *      ͥ١9
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סؿưǧ(ᥤ󥿥λˤư)
 *            OSץꥱ˽°
 *            ư줹뿮ؿ¹ԸTerminateTaskǽλ
 *            Task12ȥåͭ
 *    14
 *      IDTask14
 *      ͥ١8
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סؿưǧ(ᥤ󥿥λˤư)
 *            OSץꥱ˽°
 *            ư줹뿮ؿ¹Ըؿλ
 *            ξǤTerminateTask¹Ԥ뤫ǧ
 *            Task11ȥåͭ
 *    IocTask1
 *      IDIocTask1
 *      ͥ١9
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סIOC̿(IOC APIǡꡤ¹)Ԥ
 *            OSץꥱ˽°
 *    IocTask2
 *      IDIocTask2
 *      ͥ١9
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סIOC̿(IOC APIǡꡤ¹)Ԥ
 *            OSץꥱ˽°
 *    IocTask3
 *      IDIocTask3
 *      ͥ١9
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סIOC̿(IOC APIǡꡤ¹)Ԥ
 *            OSץꥱ˽°
 *    IocTask4
 *      IDIocTask4
 *      ͥ١9
 *      ¿ŵư1
 *      塼롧եץꥨץƥ
 *      ưưʤ
 *      סIOC̿(IOC APIǡꡤ¹)Ԥ
 *            OSץꥱ˽°
 *
 *  ߥӥ롼
 *    ꥢIO
 *      ISRIDRxHwSerialInt
 *      ͥ١2
 *      ƥꡧ2
 *      סޥɤ
 *  ꥽
 *    ٥꥽
 *      ꥽IDTskLevelRes
 *      ץѥƥɸ
 *    ѥ󥿥꥽
 *      ꥽IDCntRes
 *      ץѥƥɸ
 *    롼ץ꥽
 *      ꥽IDGroupRes
 *      ץѥƥ
 *  ٥
 *    ᥤ󥿥٥
 *      ٥IDMainEvt
 *    2٥
 *      ٥IDT2Evt
 *    3٥
 *      ٥IDT3Evt
 *  
 *    ƥॿޥ
 *      IDMAIN_HW_COUNTER
 *      ͡0999
 *      û͡1
 *    ץ륫
 *      IDSampleCnt
 *      ͡099
 *      û͡10
 *  顼
 *    ᥤ顼
 *      顼IDMainCycArm
 *      ١IDMAIN_HW_COUNTER
 *      󡧥٥ MainEvt
 *      ưưAppMode1, AppMode2, AppMode3
 *      ꡧ100100
 *    ư顼
 *      顼IDActTskArm
 *      ١IDMAIN_HW_COUNTER
 *      󡧥ư Task1
 *      ưưʤ
 *    ٥ꥢ顼
 *      顼IDSetEvtArm
 *      ١IDMAIN_HW_COUNTER
 *      󡧥٥ T3Evt
 *      ưưʤ
 *    IncrementCounterǧѥ顼
 *      顼IDSampleArm
 *      ١IDSampleCnt
 *      󡧥Хåؿ¹
 *      ưưʤ
 *    ¾OSAP°ư顼
 *      顼IDActOtherOSAPTskArm
 *      ١IDSchtblSampleCnt
 *      󡧥ư Task4
 *      ưưAppMode1, AppMode2, AppMode3
 *      ꡧ50(ñȯ)
 *  ץꥱ⡼
 *    ưưʤ⡼(MainTaskΤ߼ưư)
 *      ץꥱ⡼IDAppMode1
 *    Task1ưư⡼
 *      ץꥱ⡼IDAppMode2
 *    Task3ưư⡼
 *      ץꥱ⡼IDAppMode3
 *  ؿ
 *    ؿtfnt1
 *      OSץꥱ󤫤Ϥ줿
 *      ݥ󥿰ɽơ׻̤
 *      OSץꥱ֤
 *    ؿtfnt2
 *      OSץꥱ󤫤Ϥ줿
 *      ݥ󥿰ɽơ׻̤
 *      OSץꥱ֤
 *    ؿtfnt3
 *      OSץꥱ󤫤ShutdownOS
 *      դ
 *    ؿtfnt4
 *      OSץꥱ󤫤鿮OSץ
 *      ˽°륿ư
 *
 *  ܥեϿOSץꥱ
 *  °Ƥ륪֥,sample2.cǤ
 *  OSץꥱ˽°Ƥ
 *  ֥Ȥ򵭽ҤƤ
 */

#define TOPPERS_SVC_FUNCCALL

#include "sample.h"
#include "sample1.h"
#include "Ioc.h"

#define GetAppModeInfo()	(0)

/*
 *  ץƥȯν٥
 */
#ifdef CFG_USE_PROTECTIONHOOK
static const char8	*faulty_context_tbl[6] = {
	"FC_INVALID",
	"FC_TASK",
	"FC_C2ISR",
	"FC_SYSTEM_HOOK",
	"FC_OSAP_HOOK",
	"FC_TRUSTED_FUNC"
};
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 *  եֹ̾λѤѿ
 */
extern const char8	*fatal_file_name;   /* ե̾ */
extern sint32		fatal_line_num;     /* ֹ */

/*
 *  ؿץȥ
 */
sint32 main(void);

DEFINE_VAR_SSTACK(StackType, stack_00[COUNT_STK_T(0x200)]);

extern uint8 GetCommand(void);
extern void PutActTsk(uint8 task_no);
extern void PutActNonPriTsk(void);
extern void PutTermTsk(uint8 task_no);
extern void PutChainTsk(uint8 from_task_no, uint8 to_task_no);
extern void PutSchedule(void);
extern void PutTaskID(void);
extern void PutTaskState(uint8 task_no);
extern void PutDisAllInt(void);
extern void PutSusAllInt(void);
extern void PutSusOSInt(void);
extern void PutHwCnt3(void);
extern void PutGetCntRes(void);
extern void PutGetTskRes(void);
extern void PutRelTskRes(void);
extern void PutSetEvt(uint8 task_no);
extern void PutClrEvt(uint8 task_no);
extern void PutGetEvt(uint8 task_no);
extern void PutWaitEvt(uint8 task_no);
extern void PutArmBase(void);
extern void PutArmTick(void);
extern void PutSetRel(uint8 alarm_no, uint8 tick_no, uint8 cycle_no);
extern void PutCanArm(void);
extern void PutAppMode(void);
extern void PutActIocTsk(void);
extern void schedule_table_sample_routine(void);

TASK(IocTask3);
TASK(IocTask4);
static void IocProk2(void);
static uint8 GetCommandNoWait1(void);

/*
 *  ǡХåե
 */
extern volatile uint8 command_tbl[14];                   /* ޥɰϤơ֥ */

/*
 *  API顼ޥ
 *
 *  ErrorHookͭξErrorHook
 *  顼Ϥ, ErrorHook̵ξ
 *  ʲΥޥꥨ顼ϤԤ
 */
#if defined(CFG_USE_ERRORHOOK)
#define error_log(api)	(api)
#define error_log_ioc(api)	(api)
#else /* !defined( CFG_USE_ERRORHOOK ) */
#define	error_log(api)										   \
	{														   \
		StatusType ercd;									   \
		ercd = api;     /* API¹ */						   \
		if (ercd != E_OK) {									   \
			syslog(LOG_INFO, "Error:%d", atk2_strerror(ercd)); \
		}													   \
	}

#define	error_log_ioc(api)										   \
	{															   \
		StatusType ercd;										   \
		ercd = api;     /* API¹ */							   \
		if (ercd != E_OK) {										   \
			syslog(LOG_INFO, "Error:%d", atk2_ioc_strerror(ercd)); \
		}														   \
	}
#endif /* defined( CFG_USE_ERRORHOOK ) */

/*
 *  ؿtfnt1
 *    OSץꥱ󤫤Ϥ줿
 *    ݥ󥿰ɽơ׻̤
 *    OSץꥱ֤
 */
TRUSTEDFUNCTION(TRUSTED_tfnt1, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	sint32					*p1;
	sint32					p2;

	p1 = local->name1;
	p2 = local->name2;

	local->return_value = (StatusType) ((*p1 * 2) + p2);
	return(E_OK);
}

/*
 *  ؿtfnt2
 *    OSץꥱ󤫤Ϥ줿
 *    ݥ󥿰ɽơ׻̤
 *    OSץꥱ֤
 */
TRUSTEDFUNCTION(TRUSTED_tfnt2, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	sint32					*p1;
	sint32					p2;

	p1 = local->name1;
	p2 = local->name2;

	local->return_value = (StatusType) ((*p1 * 4) + p2);
	return(E_OK);
}

/*
 *  ؿtfnt3
 *    OSץꥱ󤫤ShutdownOS
 *    դ
 */
TRUSTEDFUNCTION(TRUSTED_tfnt3, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	StatusType				ercd;

	ercd = local->ercd;
	ShutdownOS(ercd);

	return(E_OK);
}

/*
 *  ؿtfnt4
 *    OSץꥱ󤫤鿮OSץ
 *    ˽°륿ư
 */
TRUSTEDFUNCTION(TRUSTED_tfnt4, FunctionIndex, FunctionParams)
{
	struct parameter_struct *local = FunctionParams;

	TaskType				task_no;

	task_no = local->task_no;

	error_log(ActivateTask(task_no));

	return(E_OK);
}

/*
 *  ᥤ󥿥
 *
 *  桼ޥɤμȡޥɤȤν¹
 */
TASK(MainTask)
{
	uint8					command;
	uint8					task_no;
	uint32					i;
	struct parameter_struct	local;

	TickType				val = 0U;
	TickType				eval = 0U;

	/*
	 *  ֹ桦ޥɥХåե
	 */
	task_no = (uint8) (0);
	for (i = 0U; i < (sizeof(command_tbl) / sizeof(command_tbl[0])); i++) {
		command_tbl[i] = 0U;
	}

	/*
	 *  ޥɼ¹ԥ롼
	 */
	while (1) {
		WaitEvent(MainEvt);     /* 10msκȻԤ */
		ClearEvent(MainEvt);

		/*
		 *  ϥޥɼ
		 */
		syslog(LOG_INFO, "Input Command:");
		command = GetCommand();

		/*
		 *  ϥޥɥå
		 */
		if ((command <= (uint8) (0x1fU)) || (command >= (uint8) (0x80U))) {
			syslog(LOG_INFO, "Not ASCII character");
		}
		else {
#ifndef OMIT_ECHO
			syslog(LOG_INFO, "%c", command);
#endif /* OMIT_ECHO */

			/*
			 *  ޥȽ
			 */
			switch (command) {
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
				/*
				 *  оݥѹ
				 */
				task_no = (uint8) (command - '1');
				break;
			case 'A':
			case '!':
			case '"':
			case '#':
			case '$':
			case '%':
			case 'z':
			case 'k':
			case 'K':
			case 'l':
			case 'i':
			case 'w':
			case 'W':
				/*
				 *  ؤΥޥ
				 */
				command_tbl[task_no] = command;
				break;
			/*
			 *  ʹߤϥᥤ󥿥ǥޥɽ
			 */
			case 'a':
				PutActTsk(task_no);
				break;
			case 's':
				PutSchedule();
				break;
			case 'S':
				PutActNonPriTsk();
				break;
			case 'Z':
				PutTaskState(task_no);
				break;
			case 'x':
				syslog(LOG_INFO, "call RAISE_CPU_EXCEPTION");
				RAISE_CPU_EXCEPTION;
				break;
			case 'd':
				PutDisAllInt();
				break;
			case 'D':
				PutSusAllInt();
				break;
			case 'f':
				PutSusOSInt();
				break;
			case 'T':
				PutHwCnt3();
				break;
			case 'e':
				PutSetEvt(task_no);
				break;
			case 'E':
				PutGetEvt(task_no);
				break;
			case 'b':
				PutArmBase();
				break;
			case 'B':
				PutArmTick();
				PutArmTick();
				break;
			case 'v':
				/* SetRelAlarm(ActTskArm, 500, 0)¹ */
				PutSetRel(0U, 0U, 0U);
				break;
			case 'V':
				/* SetRelAlarm(SetEvtArm, 500, 0)¹ */
				PutSetRel(1U, 0U, 0U);
				break;
			case 'h':
				/* CancelAlarm(CallBackArm)¹ */
				PutCanArm();
				break;
			case 'c':
				syslog(LOG_INFO, "Call IncrementCounter(SampleCnt)");
				IncrementCounter(SampleCnt);
				break;
			case 'C':
				syslog(LOG_INFO, "Call IncrementCounter(SampleCnt2)");
				IncrementCounter(SampleCnt2);
				break;
			case 'j':
				syslog(LOG_INFO, "GetCounterValue(MAIN_HW_COUNTER, val)");
				GetCounterValue(MAIN_HW_COUNTER, &val);
				syslog(LOG_INFO, " val = %d", val);
				break;
			case 'J':
				syslog(LOG_INFO, "Pre val = %d", val);
				syslog(LOG_INFO, "GetElapsedValue(MAIN_HW_COUNTER, val ,eval)");
				GetElapsedValue(MAIN_HW_COUNTER, &val, &eval);
				syslog(LOG_INFO, " val = %d", val);
				syslog(LOG_INFO, " eval = %d", eval);
				break;
			case 'r':
				syslog(LOG_INFO, "GetISRID() Call from Task Context");
				syslog(LOG_INFO, "GetISRID() = %d", GetISRID());
				break;
			case 'p':
				PutAppMode();
				break;
			case 't':
				schedule_table_sample_routine();
				break;
			case 'q':
				local.ercd = E_OK;
				CallTrustedFunction(tfnt3, &local); /* ShutdownOS( E_OK ) */
				break;
			case 'Q':
				local.ercd = E_OS_STATE;
				CallTrustedFunction(tfnt3, &local); /* ShutdownOS( E_OS_STATE ) */
				break;
			case 'y':
				PutActTsk(10U);
				break;
			case 'Y':
				PutActTsk(11U);
				break;
			case 'I':
				PutActIocTsk();
				break;
			default:
				/* 嵭Υޥɰʳξ硤Ԥʤ */
				break;
			}
		}
	}

	/*
	 *  ˤϤʤ
	 */
	syslog(LOG_INFO, "MainTask TERMINATE");
	error_log(TerminateTask());
}   /* TASK( MainTask ) */

/*
 *  Υץꥨץƥ֥
 *
 *  ¹ϥץꥨץȤʤȤγǧ
 */
TASK(NonPriTask)
{
	syslog(LOG_INFO, "NonPriTask ACTIVATE");
	syslog(LOG_INFO, "Call ActivateTask(HighPriorityTask)");
	error_log(ActivateTask(HighPriorityTask));
	syslog(LOG_INFO, "NonPriTask TERMINATE");

	error_log(TerminateTask());
}   /* TASK( NonPriTask ) */

/*
 *  ¹ԥ6
 */
TASK(Task6)
{
	TaskProk(5U);
}   /* TASK( Task6 ) */

/*
 *  ¹ԥ7
 */
TASK(Task7)
{
	TaskProk(6U);
}   /* TASK( Task7 ) */

/*
 *  IOCǧѥ3
 */
TASK(IocTask3)
{
	syslog(LOG_INFO, "IocTask3 ACTIVATE");

	IocProk2();

	syslog(LOG_INFO, "IocTask3 TERMINATE");
	TerminateTask();
}   /* TASK( IocTask3 ) */

/*
 *  IOCǧѥ4
 */
TASK(IocTask4)
{
	syslog(LOG_INFO, "IocTask4 ACTIVATE");

	IocProk2();

	syslog(LOG_INFO, "IocTask4 TERMINATE");
	TerminateTask();
}   /* TASK( IocTask4 ) */

/*
 *  IOCǧѥ
 *
 */
static void
IocProk2(void)
{
	uint8			api;        /* ޥɼХåե(API) */
	uint8			data[3];    /* ̿Хåե */

	volatile sint32 i;
	Std_ReturnType	ercd;

	syslog(LOG_INFO, "Select IOC API:");
	api = GetCommandNoWait1();
#ifndef OMIT_ECHO
	syslog(LOG_INFO, "%c", api);
#endif /* OMIT_ECHO */

	switch (api) {
	case '1':
		syslog(LOG_INFO, "Input send data:");
		data[0] = GetCommandNoWait1();
#ifndef OMIT_ECHO
		syslog(LOG_INFO, "%c", data[0]);
#endif /* OMIT_ECHO */
		syslog(LOG_INFO, "Call IocSend_IOC_QUE_0");
		error_log_ioc(IocSend_IOC_QUE_0(data[0]));
		break;
	case '2':
		syslog(LOG_INFO, "Input send data:");
		data[0] = GetCommandNoWait1();
#ifndef OMIT_ECHO
		syslog(LOG_INFO, "%c", data[0]);
#endif /* OMIT_ECHO */

		syslog(LOG_INFO, "Call IocSend_IOC_QUE_1");
		error_log_ioc(IocSend_IOC_QUE_1(data[0]));
		break;
	case '3':
		for (i = 0; i < 3U; i++) {
			syslog(LOG_INFO, "Input send data%d:", i);
			data[i] = GetCommandNoWait1();
#ifndef OMIT_ECHO
			syslog(LOG_INFO, "%c", data[i]);
#endif /* OMIT_ECHO */
		}
		syslog(LOG_INFO, "Call IocWriteGroup_IOC_DEQUE");
		error_log_ioc(IocWriteGroup_IOC_DEQUE(data[0], data[1], data[2]));
		break;
	case '4':
		syslog(LOG_INFO, "Call IocReceive_IOC_QUE");
		ercd = IocReceive_IOC_QUE(&data[0]);
#if !defined(CFG_USE_ERRORHOOK)
		if (ercd != E_OK) {
			syslog(LOG_INFO, "Error:%d", atk2_ioc_strerror(ercd));
		}
#endif /* !defined( CFG_USE_ERRORHOOK ) */
		if ((ercd == IOC_E_OK) || (ercd == IOC_E_LOST_DATA)) {
			syslog(LOG_INFO, "recv data:%c", data[0]);
		}
		break;
	case '5':
		syslog(LOG_INFO, "Call IocReadGroup_IOC_DEQUE");
		error_log_ioc(IocReadGroup_IOC_DEQUE(&data[0], &data[1], &data[2]));
		for (i = 0; i < 3U; i++) {
			syslog(LOG_INFO, "recv data%d:%c", i, data[i]);
		}
		break;
	case '6':
		syslog(LOG_INFO, "Call IocEmptyQueue_IOC_QUE");
		error_log_ioc(IocEmptyQueue_IOC_QUE());
		break;
	default:
		syslog(LOG_INFO, "undefined command");
		break;
	}
}   /* IocProk2 */

/*
 *  ޥɼ(̵)
 */
uint8
GetCommandNoWait1(void)
{
	uint8 command;          /* ޥɼХåե */

	/*
	 *  ޥɤޤǥ롼
	 */
	command = '\0';
	do {
		RecvPolSerialChar(&command);    /* Хåեݡ */
		if (command == '\n') {
			command = '\0';
		}
	} while (command == '\0');


	return(command);
}   /* GetCommandNoWait1 */

/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȡͥ뵯ư
 */
sint32
main(void)
{
	AppModeType	crt_app_mode;

	/*
	 *  ץꥱ⡼ɤȽ
	 */
	switch (GetAppModeInfo()) {
	case 0:
		crt_app_mode = AppMode1;
		break;
	case 1:
		crt_app_mode = AppMode2;
		break;
	default:
		crt_app_mode = AppMode3;
		break;
	}

	/*
	 *  ͥ뵯ư
	 */
	StartOS(crt_app_mode);

	while (1) {
	}
}   /* main */

/*
 *  ƥ顼եå롼
 */
#ifdef CFG_USE_SYSTEM_ERRORHOOK
void
ErrorHook(StatusType Error)
{

	/*
	 *  顼װȤΥѥ᡼
	 */
	switch (OSErrorGetServiceId()) {
	case OSServiceId_ActivateTask:
		syslog(LOG_INFO, "Error:%s=ActivateTask(%d)", atk2_strerror(Error), OSError_ActivateTask_TaskID());
		break;
	case OSServiceId_TerminateTask:
		syslog(LOG_INFO, "Error:%s=TerminateTask()", atk2_strerror(Error));
		break;
	case OSServiceId_ChainTask:
		syslog(LOG_INFO, "Error:%s=ChainTask(%d)", atk2_strerror(Error), OSError_ChainTask_TaskID());
		break;
	case OSServiceId_Schedule:
		syslog(LOG_INFO, "Error:%s=Schedule()", atk2_strerror(Error));
		break;
	case OSServiceId_GetTaskID:
		syslog(LOG_INFO, "Error:%s=GetTaskID(0x%p)", atk2_strerror(Error), OSError_GetTaskID_TaskID());
		break;
	case OSServiceId_GetTaskState:
		syslog(LOG_INFO, "Error:%s=GetTaskState(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetTaskState_TaskID(), OSError_GetTaskState_State());
		break;
	case OSServiceId_EnableAllInterrupts:
		syslog(LOG_INFO, "Error:%s=EnableAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_DisableAllInterrupts:
		syslog(LOG_INFO, "Error:%s=DisableAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_ResumeAllInterrupts:
		syslog(LOG_INFO, "Error:%s=ResumeAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_SuspendAllInterrupts:
		syslog(LOG_INFO, "Error:%s=SuspendAllInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_ResumeOSInterrupts:
		syslog(LOG_INFO, "Error:%s=ResumeOSInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_SuspendOSInterrupts:
		syslog(LOG_INFO, "Error:%s=SuspendOSInterrupts()", atk2_strerror(Error));
		break;
	case OSServiceId_GetISRID:
		syslog(LOG_INFO, "Error:%s=GetISRID()", atk2_strerror(Error));
		break;
	case OSServiceId_GetResource:
		syslog(LOG_INFO, "Error:%s=GetResource(%d)", atk2_strerror(Error), OSError_GetResource_ResID());
		break;
	case OSServiceId_ReleaseResource:
		syslog(LOG_INFO, "Error:%s=ReleaseResource(%d)", atk2_strerror(Error), OSError_ReleaseResource_ResID());
		break;
	case OSServiceId_SetEvent:
		syslog(LOG_INFO, "Error:%s=SetEvent(%d, 0x%x)", atk2_strerror(Error),
			   OSError_SetEvent_TaskID(), OSError_SetEvent_Mask());
		break;
	case OSServiceId_ClearEvent:
		syslog(LOG_INFO, "Error:%s=ClearEvent(0x%x)", atk2_strerror(Error), OSError_ClearEvent_Mask());
		break;
	case OSServiceId_GetEvent:
		syslog(LOG_INFO, "Error:%s=GetEvent(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetEvent_TaskID(), OSError_GetEvent_Event());
		break;
	case OSServiceId_WaitEvent:
		syslog(LOG_INFO, "Error:%s=WaitEvent(0x%x)", atk2_strerror(Error), OSError_WaitEvent_Mask());
		break;
	case OSServiceId_GetAlarmBase:
		syslog(LOG_INFO, "Error:%s=GetAlarmBase(0x%p)", atk2_strerror(Error), OSError_GetAlarmBase_AlarmID());
		break;
	case OSServiceId_GetAlarm:
		syslog(LOG_INFO, "Error:%s=GetAlarm(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetAlarm_AlarmID(), OSError_GetAlarm_Tick());
		break;
	case OSServiceId_SetRelAlarm:
		syslog(LOG_INFO, "Error:%s=SetRelAlarm(%d, %d, %d)", atk2_strerror(Error),
			   OSError_SetRelAlarm_AlarmID(), OSError_SetRelAlarm_increment(), OSError_SetRelAlarm_cycle());
		break;
	case OSServiceId_SetAbsAlarm:
		syslog(LOG_INFO, "Error:%s=SetAbsAlarm(%d, %d, %d)", atk2_strerror(Error),
			   OSError_SetAbsAlarm_AlarmID(), OSError_SetAbsAlarm_start(), OSError_SetAbsAlarm_cycle());
		break;
	case OSServiceId_CancelAlarm:
		syslog(LOG_INFO, "Error:%s=CancelAlarm(%d)", atk2_strerror(Error), OSError_CancelAlarm_AlarmID());
		break;
	case OSServiceId_StartScheduleTableRel:
		syslog(LOG_INFO, "Error:%s=StartScheduleTableRel(%d, %d)", atk2_strerror(Error),
			   OSError_StartScheduleTableRel_ScheduleTableID(), OSError_StartScheduleTableRel_Offset());
		break;
	case OSServiceId_StartScheduleTableAbs:
		syslog(LOG_INFO, "Error:%s=StartScheduleTableAbs(%d, %d)", atk2_strerror(Error),
			   OSError_StartScheduleTableAbs_ScheduleTableID(), OSError_StartScheduleTableAbs_Start());
		break;
	case OSServiceId_StopScheduleTable:
		syslog(LOG_INFO, "Error:%s=StopScheduleTable(%d)", atk2_strerror(Error), OSError_StopScheduleTable_ScheduleTableID());
		break;
	case OSServiceId_NextScheduleTable:
		syslog(LOG_INFO, "Error:%s=NextScheduleTable(%d, %d)", atk2_strerror(Error),
			   OSError_NextScheduleTable_ScheduleTableID_From(), OSError_NextScheduleTable_ScheduleTableID_To());
		break;
	case OSServiceId_GetScheduleTableStatus:
		syslog(LOG_INFO, "Error:%s=GetScheduleTableStatus(%d, 0x%p)", atk2_strerror(Error),
			   OSError_GetScheduleTableStatus_ScheduleTableID(), OSError_GetScheduleTableStatus_ScheduleStatus());
		break;
	case OSServiceId_GetActiveApplicationMode:
		syslog(LOG_INFO, "Error:%s=GetActiveApplicationMode()", atk2_strerror(Error));
		break;
	case OSServiceId_StartOS:
		syslog(LOG_INFO, "Error:%s=StartOS()", atk2_strerror(Error));
		break;
	case OSServiceId_ShutdownOS:
		syslog(LOG_INFO, "Error:%s=ShutdownOS()", atk2_strerror(Error));
		break;
	case OSServiceId_IncrementCounter:
		syslog(LOG_INFO, "Error:%s=IncrementCounter(%d)", atk2_strerror(Error), OSError_IncrementCounter_CounterID());
		break;
	case OSServiceId_TaskMissingEnd:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_strerror(Error));
		break;
	case IOCServiceId_IOC_Send:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_Write:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_SendGroup:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_WriteGroup:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_Receive:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_Read:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_ReceiveGroup:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_ReadGroup:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	case IOCServiceId_IOC_EmptyQueue:
		syslog(LOG_INFO, "Error:%s=MissingEnd()", atk2_ioc_strerror(Error));
		break;
	default:
		syslog(LOG_INFO, "Error:%s=UnKnownFunc()", atk2_strerror(Error));
		break;
	}

}
#endif /* CFG_USE_SYSTEM_ERRORHOOK */

/*
 *  ץ쥿եå롼
 *
 *  Task13/Task14¹Υץ쥿եåξ硤å
 */
#ifdef CFG_USE_PRETASKHOOK
void
PreTaskHook(void)
{
	TaskType tskid;

	GetTaskID(&tskid);
	if (tskid == Task13) {
		syslog(LOG_INFO, "\nPreTaskHook before Task13!\n");
	}
	if (tskid == Task14) {
		syslog(LOG_INFO, "\nPreTaskHook before Task14!\n");
	}
}
#endif /* CFG_USE_PRETASKHOOK */

/*
 *  ݥȥեå롼
 *
 *  Task13/Task14¹ԸΥݥȥեåξ硤å
 */
#ifdef CFG_USE_POSTTASKHOOK
void
PostTaskHook(void)
{
	TaskType tskid;

	GetTaskID(&tskid);
	if (tskid == Task13) {
		syslog(LOG_INFO, "\nPostTaskHook after Task13!\n");
	}
	if (tskid == Task14) {
		syslog(LOG_INFO, "\nPostTaskHook after Task14!\n");
	}
}
#endif /* CFG_USE_POSTTASKHOOK */

/*
 *  ƥȥåץեå롼
 */
#ifdef CFG_USE_SYSTEM_STARTUPHOOK
#ifdef TOPPERS_ENABLE_SYS_TIMER
extern void target_timer_initialize(void);
#endif /* TOPPERS_ENABLE_SYS_TIMER */

void
StartupHook(void)
{
#ifdef TOPPERS_ENABLE_SYS_TIMER
	target_timer_initialize();
#endif /* TOPPERS_ENABLE_SYS_TIMER */
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
}
#endif /* CFG_USE_SYSTEM_STARTUPHOOK */

/*
 *  ƥåȥեå롼
 */
#ifdef CFG_USE_SYSTEM_SHUTDOWNHOOK
#ifdef TOPPERS_ENABLE_SYS_TIMER
extern void target_timer_terminate(void);
#endif /* TOPPERS_ENABLE_SYS_TIMER */

void
ShutdownHook(StatusType Error)
{
	/* λ */
	syslog(LOG_INFO, "Sample System ShutDown");
	syslog(LOG_INFO, "ShutDownCode:%s", atk2_strerror(Error));
	syslog(LOG_INFO, "");

	if (Error == E_OS_SYS_ASSERT_FATAL) {
		syslog(LOG_INFO, "fatal_file_name:%s", fatal_file_name);
		syslog(LOG_INFO, "fatal_line_num:%d", fatal_line_num);
	}

#ifdef TOPPERS_ENABLE_SYS_TIMER
	target_timer_terminate();
#endif /* TOPPERS_ENABLE_SYS_TIMER */
	TermSerial();

}
#endif /* CFG_USE_SYSTEM_SHUTDOWNHOOK */

/*
 *  ץƥեå롼
 */
#ifdef CFG_USE_PROTECTIONHOOK
ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	StatusType			ercd;
	FaultyContextType	faulty_context;
	TaskType			taskid;

	syslog(LOG_INFO, "ProtectionHook");

	if (FatalError == E_OS_STACKFAULT) {
		syslog(LOG_INFO, "E_OS_STACKFAULT");
		ercd = PRO_SHUTDOWN;
	}
	else if (FatalError == E_OS_PROTECTION_EXCEPTION) {
		faulty_context = GetFaultyContext();
		syslog(LOG_INFO, "E_OS_PROTECTION_EXCEPTION and GetFaultyContext() = %s", faulty_context_tbl[faulty_context]);

		switch (faulty_context) {
		case FC_TASK:
			ercd = GetTaskID(&taskid);
			if (taskid == MainTask) {
				ercd = PRO_IGNORE;
			}
			else {
				ercd = PRO_TERMINATETASKISR;
			}
			break;
		case FC_C2ISR:
			ercd = PRO_TERMINATETASKISR;
			break;
		case FC_OSAP_HOOK:
			ercd = PRO_TERMINATEAPPL;
			break;
		case FC_SYSTEM_HOOK:
			ercd = PRO_IGNORE;
			break;
		case FC_TRUSTED_FUNC:
			ercd = PRO_IGNORE;
			break;
		case FC_INVALID:
			ercd = PRO_SHUTDOWN;
			break;
		default:
			ercd = PRO_SHUTDOWN;
			syslog(LOG_INFO, "unknown error fo GetFaultyContext() = %d", faulty_context);
		}
	}
	else {
		ercd = PRO_SHUTDOWN;
	}

	return(ercd);
}
#endif /* CFG_USE_PROTECTIONHOOK */

/*
 *  OSAPȥåץեå롼
 */
#ifdef CFG_USE_OSAP_STARTUPHOOK
void
StartupHook_KT_osap(void)
{
	syslog(LOG_INFO, "Sample StartupHook_KT_osap!\n");
}
#endif /* CFG_USE_OSAP_SHUTDOWNHOOK */
