/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2014 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2014 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2014 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2014 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2014 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: chkobj.c 345 2014-09-16 23:55:32Z fsi-dankei $
 */

#include	"Os.h"

#include	<stdarg.h>

/*
 *  CheckObjectAccess()
 *   OSץꥱΥ֥ȥݤå
 *
 *  ѰѤ뤿ᡤ桼ȤΥ󥿥եĴؿ
 *  饤֥Ȥ󶡤åΤϥͥǹԤ
 *
 *  va_arg()  2ϡФ٤η򼨤
 *  ǤTaskTypeʤɤꤹ٤Ǥ뤬xxxTypeuint32Ǥ
 *  va_arg()  2 int( double) ʳηꤹȥ
 *  餬ɤʤ(ɻߤΤᶯŪCPU㳰
 *  ȯ̿)
 *  Τᡤη(TaskTypeʤ)ꤹ뤳ȤʤΤǡ
 *  "uint32"Ȥ
 */

ObjectAccessType
CheckObjectAccess(ApplicationType ApplID, ObjectTypeType ObjectType, ...)
{
	ObjectAccessType	access = NO_ACCESS;
	va_list				ap;
	uint32				object_id;

	va_start(ap, ObjectType);
	object_id = va_arg(ap, uint32);
	va_end(ap);

	switch (ObjectType) {
	case OBJECT_TASK:
		access = CheckTaskAccess(ApplID, object_id);
		break;

	case OBJECT_ISR:
		access = CheckISRAccess(ApplID, object_id);
		break;

	case OBJECT_ALARM:
		access = CheckAlarmAccess(ApplID, object_id);
		break;

	case OBJECT_RESOURCE:
		access = CheckResourceAccess(ApplID, object_id);
		break;

	case OBJECT_COUNTER:
		access = CheckCounterAccess(ApplID, object_id);
		break;

	case OBJECT_SCHEDULETABLE:
		access = CheckScheduleTableAccess(ApplID, object_id);
		break;

	default:
		access = NO_ACCESS;
		break;
	}

	return(access);
}

/*
 *  CheckObjectOwnership()
 *   OSץꥱΥ֥Ƚͭå
 *
 *  ѰѤ뤿ᡤ桼ȤΥ󥿥եĴؿ
 *  饤֥Ȥ󶡤åΤϥͥǹԤ
 *
 *  va_arg()  2ϡФ٤η򼨤
 *  ǤTaskTypeʤɤꤹ٤Ǥ뤬xxxTypeuint32Ǥ
 *  va_arg()  2 int( double) ʳηꤹȥ
 *  餬ɤʤ(ɻߤΤᶯŪCPU㳰
 *  ȯ̿)
 *  Τᡤη(TaskTypeʤ)ꤹ뤳ȤʤΤǡ
 *  "uint32"Ȥ
 */

ApplicationType
CheckObjectOwnership(ObjectTypeType ObjectType, ...)
{
	ApplicationType owner = INVALID_OSAPPLICATION;
	va_list			ap;
	uint32			object_id;

	va_start(ap, ObjectType);
	object_id = va_arg(ap, uint32);
	va_end(ap);

	switch (ObjectType) {
	case OBJECT_TASK:
		owner = CheckTaskOwnership(object_id);
		break;

	case OBJECT_ISR:
		owner = CheckISROwnership(object_id);
		break;

	case OBJECT_ALARM:
		owner = CheckAlarmOwnership(object_id);
		break;

	case OBJECT_COUNTER:
		owner = CheckCounterOwnership(object_id);
		break;

	case OBJECT_SCHEDULETABLE:
		owner = CheckScheduleTableOwnership(object_id);
		break;

	default:
		owner = INVALID_OSAPPLICATION;
		break;
	}

	return(owner);
}
